package org.jeecg.modules.flowable.controller;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.modules.flowable.apithird.business.entity.SysDeployForm;
import org.jeecg.modules.flowable.apithird.business.service.ISysDeployFormService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.Arrays;

 /**
 * @Description: 流程实例关联表单对象
 * @Author: jeecg-boot
 * @Date:   2025-09-15
 * @Version: V1.0
 */
@Api(tags="流程实例关联表单对象")
@RestController
@RequestMapping("/flowable/sysDeployForm")
@Slf4j
public class SysDeployFormController extends JeecgController<SysDeployForm, ISysDeployFormService> {
	@Autowired
	private ISysDeployFormService sysDeployFormService;

	@ApiOperation(value="流程实例关联表单对象-分页列表查询", notes="流程实例关联表单对象-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<SysDeployForm>> queryPageList(SysDeployForm sysDeployForm,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<SysDeployForm> queryWrapper = QueryGenerator.initQueryWrapper(sysDeployForm, req.getParameterMap());
		Page<SysDeployForm> page = new Page<SysDeployForm>(pageNo, pageSize);
		IPage<SysDeployForm> pageList = sysDeployFormService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	@AutoLog(value = "流程实例关联表单对象-添加")
	@ApiOperation(value="流程实例关联表单对象-添加", notes="流程实例关联表单对象-添加")
	//@RequiresPermissions("flowable:sys_deploy_form:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody SysDeployForm sysDeployForm) {
		deleteByDeployedId(sysDeployForm.getDeployId());
		sysDeployFormService.save(sysDeployForm);
		return Result.OK("添加成功！");
	}

	@AutoLog(value = "流程实例关联表单对象-编辑")
	@ApiOperation(value="流程实例关联表单对象-编辑", notes="流程实例关联表单对象-编辑")
	//@RequiresPermissions("flowable:sys_deploy_form:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody SysDeployForm sysDeployForm) {
		sysDeployFormService.updateById(sysDeployForm);
		return Result.OK("编辑成功!");
	}

	@AutoLog(value = "流程实例关联表单对象-通过id删除")
	@ApiOperation(value="流程实例关联表单对象-通过id删除", notes="流程实例关联表单对象-通过id删除")
	//@RequiresPermissions("flowable:sys_deploy_form:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		sysDeployFormService.removeById(id);
		return Result.OK("删除成功!");
	}

	@AutoLog(value = "流程实例关联表单对象-批量删除")
	@ApiOperation(value="流程实例关联表单对象-批量删除", notes="流程实例关联表单对象-批量删除")
	//@RequiresPermissions("flowable:sys_deploy_form:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.sysDeployFormService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	@ApiOperation(value="流程实例关联表单对象-通过id查询", notes="流程实例关联表单对象-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<SysDeployForm> queryById(@RequestParam(name="id",required=true) String id) {
		SysDeployForm sysDeployForm = sysDeployFormService.getById(id);
		if(sysDeployForm==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(sysDeployForm);
	}

    @RequiresPermissions("flowable:sys_deploy_form:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, SysDeployForm sysDeployForm) {
        return super.exportXls(request, sysDeployForm, SysDeployForm.class, "流程实例关联表单对象");
    }

    @RequiresPermissions("flowable:sys_deploy_form:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, SysDeployForm.class);
    }

	private void deleteByDeployedId(String deployedId) {
		if(deployedId!=null) {
			LambdaQueryWrapper<SysDeployForm> wrapper = new LambdaQueryWrapper<>();
			wrapper.eq(SysDeployForm::getDeployId, deployedId);
			sysDeployFormService.remove(wrapper);
		}
	 }

}
